workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
    - if: $CI_PIPELINE_SOURCE == "web"
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH == "develop" && $CI_PIPELINE_SOURCE == "push"
    - if: $CI_COMMIT_BRANCH == "release" && $CI_PIPELINE_SOURCE == "push"
    - if: $CI_COMMIT_BRANCH == "master" && $CI_PIPELINE_SOURCE == "push"

include:
  - remote: 'https://gitlab.com/__amish__/shared-ci/-/raw/main/.ci/after-script.yml'

image: node:latest

variables:
  GIT_STRATEGY: fetch
  GIT_CHECKOUT: 'true'
  GIT_CLONE_PATH: $CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/$CI_COMMIT_BRANCH/$CI_COMMIT_SHA
  ROOT_DIR: $CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/$CI_COMMIT_BRANCH/$CI_COMMIT_SHA
  SLACK_MOBILE_PIPELINE: '#mobile_pipeline'


stages:
  - prepare
  - test

install_yarn:
  stage: prepare
  script:
    - find ../ -maxdepth 1 -mtime +1 -exec rm -rf {} \;
    - find ../.. -maxdepth 1 -mtime +1 -exec rm -rf {} \;
    - yarn

run-test:
  stage: test
  variables:
    GIT_STRATEGY: none
    GIT_CHECKOUT: 'false'
    GIT_CLONE_PATH: '${ROOT_DIR}'
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH == "develop" && $CI_PIPELINE_SOURCE == "push"
    - if: $CI_COMMIT_BRANCH == "release" && $CI_PIPELINE_SOURCE == "push"
    - if: $CI_COMMIT_BRANCH == "master" && $CI_PIPELINE_SOURCE == "push"
  script:
    - echo "testing"
    - yarn test
